# Boots Client
# www.launchpad.net/boots
# www.launchpad.net/drizzle
# lib/lingos/lisp/lexer.py
#
# ##### BEGIN LICENSE BLOCK #####
# Version: MPL 1.1
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
# The Original Code is Boots Client code.
#
# The Initial Developer of the Original Code is Clark Boylan, Ken
# Brotherton, Max Goodman, Victoria Lewis, David Rosenbaum, and Andreas
# Turriff. Portions created by Clark Boylan, Ken Brotherton, Max Goodman,
# Victoria Lewis, David Rosenbaum, and Andreas Turriff are Copyright (C)
# 2009. All Rights Reserved.
#
# Contributor(s):
#
# ##### END LICENSE BLOCK #####
# Defines the lisp lexer.

import ply.lex as lex

tokens = ('INTEGER', 'STRING', 'SYMBOL', 'QUOTE', 'LEFT_PAREN', 'RIGHT_PAREN')

t_INTEGER = r'[0-9]+'
t_STRING = r'"[^"]*"'
t_SYMBOL = r'[^\t\n ()0-9\'"][^\t\n ()\'"]*'
t_QUOTE = r"'"
t_LEFT_PAREN = r'\('
t_RIGHT_PAREN = r'\)'
t_ignore = ' \t\n'

def t_error(t):
    print('illegal character {0} found'.format(t.value))
    token.lexer.skip(1)

lexer = lex.lex()
